<template>
  <div>
    <q-table
      title="Semua User"
      class="table-produk-saya"
      :data="data"
      :columns="columns"
      row-key="id"
      :pagination.sync="pagination"
      :loading="loading"
      :filter="filter"
      @request="onRequest"
      binary-state-sort
    >
      <template v-slot:top-right style="color: white !important;">
        <q-input borderless dense debounce="300" v-model="filter" placeholder="Cari Produk" @input="onRequest" color="white">
          <template v-slot:append style="color: white">
            <q-icon name="search"  />
          </template>
        </q-input>
      </template>

      <template v-slot:body="props">
        <q-tr :props="props" :key="`m_${props.row.index}`">
          <q-td
            style="width: 30px"
            key="index"
            :props="props"
          >
            {{ props.row.index }}.
          </q-td>
          <q-td key="avatar" :props="props" >
            <q-avatar size="75px">
              <img :src="props.row.avatar || 'avatar.jpg'">
            </q-avatar>
          </q-td>
          <q-td style="width: 150px" key="name" :props="props" >{{ props.row.name }}</q-td>
          <q-td style="width: 150px" key="email" :props="props" >{{ props.row.email }}</q-td>
          <q-td style="width: 150px" key="jenis_user" :props="props" >
            <q-badge label="User" v-if="props.row.jenis_user == 0" />
            <q-badge label="Administrator" color="red"  v-if="props.row.jenis_user == 1" />
            <q-badge label="Provider" color="yellow" style="color: black"  v-if="props.row.jenis_user == 2"  />
          </q-td>
          <q-td style="width: 150px" key="level" :props="props" >
            <q-badge label="Silver" color="grey" />
          </q-td>
          <q-td style="width: 150px" key="status" :props="props" >
            <q-badge label="Aktif" color="green" v-if="props.row.status == 0" />
            <q-badge label="Tidak Aktif" color="red" v-else />
          </q-td>
          <q-td key="actions" :props="props" style="padding-left: 0; padding-right: 0">
            <q-btn-group>
              <q-btn size="10px" color="green" :to="`/user/role/${props.row.id}`"  >Update Role</q-btn>
              <q-btn size="10px" color="primary" >Detail</q-btn>
              <q-btn size="10px" color="orange" >Edit</q-btn>
              <q-btn size="10px" color="red" type="a" :to="`/user/hapus/${props.row.id}`"  >Hapus</q-btn>
            </q-btn-group>
          </q-td>
        </q-tr>
      </template>
    </q-table>
  </div>
</template>

<script>
export default {
  data () {
    return {
      filter: '',
      loading: false,
      token: localStorage.getItem("token"),
      pagination: {
        sortBy: 'index',
        descending: true,
        page: 1,
        rowsPerPage: 5,
        rowsNumber: 10
      },
      columns: [
        {
          name: 'index',
          required: true,
          label: 'No',
          align: 'left',
          field: 'index',
          format: val => `${val}`,
          sortable: true
        },
        { name: 'avatar', align: 'center', label: 'Avatar', field: 'avatar', sortable: true },
        { name: 'name', align: 'center', label: 'Nama Lengkap', field: 'name', sortable: true },
        { name: 'email', align: 'center', label: 'Email', field: 'email', sortable: true },
        { name: 'jenis_user', align: 'center', label: 'Jenis User', field: 'jenis_user', sortable: true},
        { name: 'level', align: 'center', label: 'Level User', field: 'level', sortable: true},
        { name: 'status', align: 'center', label: 'Status', field: 'status', sortable: true },
        { name: 'actions', align: 'center', label: 'Aksi', field: 'status', sortable: true },
      ],
      data: [],
    }
  },

  filters: {
    currency(price) {
      return new Intl.NumberFormat("id-ID", {
        style: "currency",
        currency: "IDR",
        minimumFractionDigits: 2
      }).format(price);
    }
  },

  mounted () {
    // get initial data from server (1st page)
    this.onRequest({
      pagination: this.pagination,
      filter: undefined
    })
  },
  methods: {
    hapusProduct: function (id) {
      alert(id)
    },

    showImage(val) {
      this.$q.dialog({
        message: `<img src="${val}" style="width: 100%" />`,
        html: true,
      })
    },
    onRequest (props) {
      console.log("props", props);

      const { descending, page, rowsNumber, rowsPerPage, sortBy } = props.pagination;
      const filter = props.filter

      if (! descending) {
        this.pagination.descending = true
      }

      this.loading = true
      let apiUrl =
        `api/user/list?page=${page}&perPage=${rowsPerPage}&sortBy=${sortBy}&filter=${filter}&descending=${descending}`

      let config = {
        method: "get",
        url: apiUrl ,
        headers: {
          Authorization: "Bearer " + this.token
        }
      }

      this.$axios(config)
        .then(response => {

          let data = response.data

          this.data = data.data

          this.data.forEach((row, index) => {
            row.index = index + 1 + ((page-1)*rowsPerPage)
          })

          this.pagination = {
            sortBy: 'index',
            descending: descending,
            page: data.current_page,
            rowsPerPage: data.per_page,
            rowsNumber: data.total
          }

        })
        .catch(error => {
          console.log(error)
        })
        .then(always => {
          this.loading = false
        })
    },
  }
}
</script>

<style lang="sass" scoped>
.q-table--no-wrap td
  white-space: normal

  .table-produk-saya

    .q-table__top,
    .q-table__bottom,
    thead tr:first-child th
      /* bg color is important for th; just specify one */
      background-color: #009688
      color: white
      font-size: 16px

    thead tr th
      position: sticky
      z-index: 1
    thead tr:first-child th
      top: 0

    /* this is when the loading indicator appears */
    &.q-table--loading thead tr:last-child th
      /* height of all previous header rows */
      top: 48px
</style>

